package controlador;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;

import modelo.Carta;
import modelo.Jugador;
import modelo.Modelo;
import vista.AcercaDe;
import vista.BotonCarta;
import vista.Instrucciones;
import vista.Vista;

public class Controlador implements ActionListener {

	private Modelo modelo;
	private Vista vista;

	public Controlador(Vista vista, Modelo modelo) {
		this.vista = vista;
		this.modelo = modelo;

	}


	public void actionPerformed(ActionEvent e) {

		String command = e.getActionCommand();

		if (command.equals("btnComenzar")) {
			modelo.inicializa(vista.pnlDatos.txtNombre.getText());
			Carta top = modelo.getTop();

			// Muestra la carta inicial
			vista.pnlJuego.panel_5.lblMesa.setText(top.toString());
			vista.pnlJuego.incializa(modelo.jugadores);

			// Aadimos las cartas del jugador humano
			Jugador j = modelo.getJugador(0);
			BotonCarta b;
			for (int i = 0; i < j.size(); i++) {
				b = new BotonCarta(j.getCarta(i));
				b.setEnabled(false);
				b.setActionCommand("botonCarta");
				vista.pnlJuego.cartas.add(b);
			}

			vista.setContentPane(vista.pnlJuego);
			vista.setSize(vista.getContentPane().getSize());

			// Carta inicial con efecto?
			switch (top.getNumero()) {
			case 7:
				modelo.setSentido();
				modelo.setSig(3);
				vista.pnlJuego.lblSentido.setIcon(new ImageIcon(Vista.class
						.getResource("/resources/horario.jpg")));
				vista.pnlJuego.setJugador(3);
				break;

			// Caballo
			case 12:
				vista.pnlJuego.setJugador(2);
				break;

			default:
				vista.pnlJuego.setJugador(1);
				break;
			}
			actualizaVista();
			turno();
		}

		if (command.equals("instrucciones")) {
			Instrucciones ins = new Instrucciones();
			ins.setVisible(true);
		}

		if (command.equals("acercaDe")) {
			AcercaDe acerca = new AcercaDe();
			acerca.setVisible(true);
		}

		if (command.equals("salir")) {
			System.exit(0);

		}

		if (command.equals("aceptaTurno")) {
			actualizaVista();
			modelo.mensaje.setVisible(false);
			modelo.mensaje.dispose();
			if(modelo.sig == 0){//Turno humano
				if(modelo.robar == 0){//Turno normal humano
					actualizaVista();
					//turno();
				}else{// Turno robar humano
					modelo.jugTurno.roba(modelo.robar, modelo.baraja, modelo.mazo);
					modelo.setRobar(0);
					//turno();
					
				}
			}else{
				turno();
			}
			
		}
		
		if(command.equals("botonCarta")){
			BotonCarta bc = (BotonCarta)e.getSource();
			modelo.jugTurno.remove(bc.carta);
			modelo.mazo.add(bc.carta);
			modelo.jugTurno.remove(bc.carta);
			vista.pnlJuego.cartas.remove(bc);
			System.out.println(modelo.sig);
			modelo.setSig();
			System.out.println(modelo.sig);
			actualizaVista();
			turno();
		}
		
		if(command.equals("nuevo")){
			modelo.sig = 0;
			modelo.sentido = 1;
			modelo.robar = 0;
			iniciar_vista();
		}
		
		if(command.equals("robar")){
			modelo.jugTurno.roba(2, modelo.baraja, modelo.mazo);
			((JButton)e.getSource()).setEnabled(false);
			modelo.setSig();
			actualizaVista();
			turno();
		}

	}

	public void iniciar_vista() {
		// asignamos esta clase como manejador de eventos de todos los botones
		vista.pnlDatos.btnComenzar.addActionListener(this);
		modelo.mensaje.boton.addActionListener(this);
		vista.pnlJuego.panel_5.btnNewButton.addActionListener(this);
		
		//asignamos el manejador de eventos para la barra de menu
		vista.mntmInstrucciones.addActionListener(this);
		vista.mntmAcercaDe.addActionListener(this);
		vista.mntmNuevo.addActionListener(this);
		vista.mntmSalir.addActionListener(this);
		
		//mostramos la vista
		vista.setContentPane(vista.pnlDatos);
		vista.setVisible(true);
		
	}

	public void turno() {
		actualizaVista();
		modelo.turno();
	}

	public void actualizaVista() {
		vista.pnlJuego.setJugador(modelo.sig);
		vista.pnlJuego.setMesa(modelo.getTop());
		vista.pnlJuego.setNumCartas(modelo.jugadores);
		vista.pnlJuego.setSentido(modelo.sentido);
		//vista.pnlJuego.cartas.setCartas(modelo.getJugador(0));
		//vista.pnlJuego.cartas = new PanelCartas(modelo.getJugador(0).getReparto());
		//setCartas(modelo.getJugador(0).getReparto());
		
		int tam = modelo.getJugador(0).size();
		boolean tengo = false;
		//vista.pnlJuego.cartas.cartas.clear();
		vista.pnlJuego.cartas.removeAll();
		vista.pnlJuego.repaint();
		BotonCarta bc;
		for(int i=0;i<tam;i++){
			bc = new BotonCarta(modelo.getJugador(0).getCarta(i));
			bc.setActionCommand("botonCarta");
			bc.addActionListener(this);
			bc.setEnabled(false);
			if(bc.getNumero()==modelo.getTop().getNumero() || bc.getPalo()==modelo.getTop().getPalo()){
				bc.setEnabled(true);
				tengo = true;
			}
			//vista.pnlJuego.cartas.cartas.add(bc);
			vista.pnlJuego.cartas.add(bc);
			
			if(!tengo){
				vista.pnlJuego.panel_5.btnNewButton.setEnabled(true);
			}
			
		}
		vista.pnlJuego.cartas.repaint();

	}
	
//	public void activarCartasNormal() {
//		boolean tengo = false;
//		Jugador humano = modelo.getJugador(0);
//		Carta top = modelo.getTop();
//		BotonCarta bc;
//		System.out.println("top: "+top.toString());
//		// Activo cartas para echar
//		for (int i = 0; i < humano.size(); i++) {
//			//BotonCarta bc = (BotonCarta) vista.pnlJuego.cartas.getComponent(i);
//			bc = vista.pnlJuego.cartas.getCarta(i);
//			//BotonCarta bc = vista.pnlJuego.cartas.getCarta(i);
//			if (bc.getNumero() == top.getNumero()
//					|| bc.getPalo() == top.getPalo() || bc.getNumero() == 11) {
//				bc.setEnabled(true);
//				bc.addActionListener(this);
//				bc.setActionCommand("botonCarta");
//				tengo = true;
//			}
//		}
//	}
	
//	public void setCartas(List<Carta> c){
//		BotonCarta bc;
//		vista.pnlJuego.cartas.removeAll();
//		
//		int  tam = c.size();
//		for (int i=0; i<tam;i++) {
//			bc = new BotonCarta(c.get(i));
//			vista.pnlJuego.cartas.cartas.add(bc);
//			bc.setActionCommand("botonCarta");
//			bc.setEnabled(false);
//			bc.setVisible(true);
//		}
//	}

}
