/************************************************
 * 
 * 
 * 			Picross! v2.3
 * 
 *  Autor: Alejandro Raposo Lpez
 *  e-mail: arletsii@gmail.com
 * 
 * 
 *************************************************/

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.Random;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;


public class Picross extends JFrame implements ActionListener,WindowListener {


	private static final long serialVersionUID = 1L;
	private JPanel mpanel;			//panel principal
	private JMenuBar mbar;			//barra menu
	private JPanel tabpanel;		//panel tablero jugador
	private JPanel pop;				//panel opciones {dificultad,botones}
	private JPanel pcont;			//panel para el contador
	private JDialog dialog;			//dialog {instrucciones, acerca}
	private boolean[][] tablero;	//tablero a resolver
	private boolean[][] tableroj;	//tablero actual del jugador
	private JButton[][] abutton;	//array de JButton
	private int ndif;				//nivel dificultad={1,2,3}
	private JRadioButton facil;
	private JRadioButton normal;
	private JRadioButton dificil;

	private Contador cont;
	
	
	public Picross(){
		super("Picross!");
		setSize(220,200);
		setResizable(false);
		setLocation(new Point(300,200));
		cont = new Contador();
		
		
		creaMenu();
		creaOpciones();

		
		//Panel Principal (contenedor global)
		mpanel = new JPanel();
		mpanel.setLayout(new BorderLayout());
		mpanel.setBackground(Color.blue);

		//Globales
		addWindowListener(this);
		setJMenuBar(mbar);
		setVisible(true);

		
	}
	
	
	public void windowClosing(WindowEvent e){System.exit(0);}
	public void windowOpened(WindowEvent e){}
	public void windowClosed(WindowEvent e){}
	public void windowActivated(WindowEvent e){}
	public void windowDeactivated(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
	
	public void actionPerformed(ActionEvent e){
		String c = e.getActionCommand();
		if(c.equals("Salir"))
			System.exit(0);
		
		if(c.equals("Resolver")){
			for(int i=0;i<5*ndif;i++){
				for(int j=0;j<5*ndif;j++){
					if(tablero[i][j])
						abutton[i][j].setBackground(Color.black);
					else
						abutton[i][j].setBackground(Color.white);
				}
			}
			if(cont.getActivo())
				cont.resuelve();
		}
		if(c.equals("clic")){
			JButton baux =((JButton)e.getSource());
			Color col = new Color(150,150,150);
			if(baux.getBackground().equals(Color.black)){
				baux.setBackground(Color.white);
			}
			else{
				if(baux.getBackground().equals(Color.white)){
					baux.setBackground(col);
				}
				else{
					baux.setBackground(Color.black);
				}
			}
		}
		
		if(c.equals("Comprobar")){
			boolean b = true;
			for(int i=0;i<5*ndif;i++){
				for(int j=0;j<5*ndif;j++){
					JButton baux =abutton[i][j];
					if(baux.getBackground().equals(Color.black))
						tableroj[i][j]=true;
					else{
						if(baux.getBackground().equals(Color.white))
							tableroj[i][j]=false;
						else
							b=false;
					}
					
					b = b && (tablero[i][j]==tableroj[i][j]);
				}
			}
			if(b){
				((JButton)e.getSource()).setBackground(Color.green);
				cont.pararContador();
				
			}
			else{
				((JButton)e.getSource()).setBackground(Color.red);
			}
		}
		if(c.equals("Aceptar")){
			if(facil.isSelected())
				ndif=1;
			else{
				if(normal.isSelected())
					ndif=2;
				else
					ndif=3;
			}
		
			
			switch(ndif){
				case 1:
					setSize(221,220);
					break;
				case 2:
					setSize(460,420);
					break;
				default:
					setSize(830,620);
			}
			//TODO creaContador();
			cont.creaContador();
			setContentPane(mpanel);
			remove(pop);
			creaTablero();
			
		}
		if(c.equals("Acerca")){
			dialog = new JDialog(this,"Acerca de...",true);
			Container pacer = dialog.getContentPane();
			JTextArea jta = new JTextArea("Picross! v2.3\n\n"+
										"Desarrollado por:\n\tAlejandro Raposo Lpez\n\n"+
										"Agradecimientos:\n" +
										"A todas aquellas personas que han contribuido al desarrollo."+
										"\n\nA ti por jugar!");
			jta.setEditable(false);
			jta.setFocusable(false);
			pacer.add(jta,BorderLayout.CENTER);
			dialog.setSize(450, 190);
			dialog.setResizable(false);
			dialog.setVisible(true);
		}
		if(c.equals("Instr")){
			dialog = new JDialog(this,"Como jugar...",true);
			Container pacer = dialog.getContentPane();
			JTextArea jta = new JTextArea("El objetivo del juego consiste en rellenar \n\tla cuadrcula con cuadros negros y blancos.\n"+
					"Los nmeros de los mrgenes indican\n\tlos grupos de casillas negras de dicha fila o columna.\n\n"+
					"Por ejemplo:\n\t12: Primero un grupo de UN cuadrado negro y \n\t despuss un grupo de DOS cuadrados negros en esa fila/columna\n\nSuerte!");
			jta.setEditable(false);
			jta.setFocusable(false);
			pacer.add(jta,BorderLayout.CENTER);
			dialog.setSize(600, 190);
			dialog.setResizable(false);
			dialog.setVisible(true);
		}
		if(c.equals("Nuevo")){
			if(!getContentPane().equals(pop)){
				mpanel.removeAll();
				setSize(220,200);
				creaOpciones();
			}
		}
	}
	

	private void creaOpciones(){
		//--------------------------------------------------
		//Opciones

		
		//Panel opciones
		pop = new JPanel(new BorderLayout());
		
		//Panel opciones Norte
		JPanel popn = new JPanel(new GridLayout(4,1));
		
		ButtonGroup dif = new ButtonGroup();
		facil = new JRadioButton("Fcil",true);
		normal = new JRadioButton("Normal",false);
		dificil = new JRadioButton("Difcil",false);
		
		dif.add(facil);
		dif.add(normal);
		dif.add(dificil);
		
		popn.add(new JLabel("Elige dificultad:"));
		popn.add(facil);
		popn.add(normal);
		popn.add(dificil);
		
		//Boton sur
		JButton aceptar = new JButton("Aceptar");
			aceptar.addActionListener(this);
			aceptar.setActionCommand("Aceptar");
			
		
		pop.add(aceptar, BorderLayout.SOUTH);
		pop.add(popn, BorderLayout.CENTER);
		//-----------------------------------------------------------
		
		setContentPane(pop);
	}
	
	private void creaTablero(){
		tablero = new boolean[5*ndif][5*ndif]; 
		tableroj = new boolean[5*ndif][5*ndif];
		Random rnd = new Random();
		
		for(int i=0;i<5*ndif;i++){
			for(int j=0;j<5*ndif;j++){
				tablero[i][j]=rnd.nextBoolean();
			}
		}
		
		//Tablero
		abutton = new JButton[5*ndif][5*ndif];
		tabpanel = new JPanel();
		tabpanel.setLayout(new GridLayout(5*ndif,5*ndif));
		for(int i=0;i<5*ndif;i++){
			for(int j=0;j<5*ndif;j++){
				abutton[i][j]= new JButton();
				abutton[i][j].setBackground(Color.blue);
				abutton[i][j].addActionListener(this);
				abutton[i][j].setActionCommand("clic");
				tabpanel.add(abutton[i][j]);
			}
		}
		
		JPanel ptot = new JPanel(new BorderLayout());
			
		
		//TODO Panel Contador
		//Panel que alberga el contador de tiempo
		pcont = new JPanel();
			pcont.add(cont);
			cont.setVisible(true);
			
			

		
			
		//Panel pguian
		JPanel pguian = new JPanel();
			pguian.setLayout(new GridLayout(1,1+5*ndif));
			pguian.add(new JLabel());
		Dimension dim = pguian.getSize();
		
		ptot.add(pguian,BorderLayout.NORTH);
		
		//Panel pguiao
		JPanel pguiao = new JPanel();
			pguiao.setLayout(new GridLayout(5*ndif,1));
			pguiao.setSize((int)dim.getHeight(), (int)dim.getWidth());
		
		for(int i=0;i<5*ndif;i++){
			pguian.add(new JLabel(valorAsociado(false,i),SwingConstants.CENTER));
			pguiao.add(new JLabel(valorAsociado(true,i),SwingConstants.CENTER));

		}
		
		//Panel sur
		JPanel psur = new JPanel(new GridLayout(1,2));
			

		
		JButton comp = new JButton("Comprobar");
			comp.setActionCommand("Comprobar");
			comp.addActionListener(this);
		psur.add(comp);
		
		JButton res = new JButton("Resolver");
			res.setActionCommand("Resolver");
			res.addActionListener(this);
		psur.add(res);
		
		
		ptot.add(pguian,BorderLayout.NORTH);
		ptot.add(psur, BorderLayout.SOUTH);
		ptot.add(pguiao, BorderLayout.WEST);
		ptot.add(tabpanel, BorderLayout.CENTER);

		mpanel.add(pcont,BorderLayout.NORTH);
		mpanel.add(ptot,BorderLayout.CENTER);
	}
		
	private void creaMenu(){
		//Barra de Menu
		mbar = new JMenuBar();
		JMenu m1 = new JMenu("Juego");
		JMenu m2 = new JMenu("Ayuda");
		
		JMenuItem m11 = new JMenuItem("Nuevo...");
			m11.setActionCommand("Nuevo");
			m11.addActionListener(this);
		JMenuItem m12 = new JMenuItem("Salir");
			m12.setActionCommand("Salir");
			m12.addActionListener(this);
			
		JMenuItem m21 = new JMenuItem("Como jugar...");
			m21.setActionCommand("Instr");
			m21.addActionListener(this);
		
		JMenuItem m22 = new JMenuItem("Acerca de...");
			m22.setActionCommand("Acerca");
			m22.addActionListener(this);
			
		
		mbar.add(m1);
		m1.add(m11);
		m1.add(m12);
		mbar.add(m2);
		m2.add(m21);
		m2.add(m22);		
		// Fin Menu
		//-----------------------------------------------------------
	}

	
	//Valor asociado a la fila o columna fc
	private String valorAsociado(boolean fila,int fc){
		String vret =new String();
		int suc=0;
		
		if(fila){
			for(int i=0;i<5*ndif;i++){
				if(tablero[fc][i])
					suc++;
				else{
					if(suc!=0){
						if(suc>9)
							vret+="("+suc+")";
						else
							vret+=suc;
					}		
					suc=0;	
				}
			}
		}
		else{
			for(int i=0;i<5*ndif;i++){
				if(tablero[i][fc])
					suc++;
				else{
					if(suc!=0){
						if(suc>9)
							vret+="("+suc+")";
						else
							vret+=suc;
					}		
					suc=0;
				}
			}
		}
		
		if(suc!=0){
			if(suc>9)
				vret+="("+suc+")";
			else
				vret+=suc;
		}
		if(vret.equals(""))
			vret="0";
		return vret;
	}
	


	public static void main(String args[]){
		new Picross();
	}
}